package ru.landgrafhomyak.bgtu.db0.storage.serdha.schema.v0

import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.HAS_ROWS
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.U8
import ru.landgrafhomyak.bgtu.db0.storage.serdha.schema._temp.selectOneOrError
import ru.landgrafhomyak.db.serdha0.api.misc.RowExpression
import ru.landgrafhomyak.db.serdha0.api.misc._Selectable
import ru.landgrafhomyak.db.serdha0.api.queries.SelectQuery
import ru.landgrafhomyak.db.serdha0.api.queries._Query
import ru.landgrafhomyak.db.serdha0.api.runtime.OutputRow
import ru.landgrafhomyak.db.serdha0.api.runtime.Transaction
import ru.landgrafhomyak.db.serdha0.api.table.ForeignRowReference
import ru.landgrafhomyak.db.serdha0.api.table.Table
import ru.landgrafhomyak.db.serdha0.api.table.TableConstructor

@Suppress("ClassName", "PropertyName", "MemberVisibilityCanBePrivate")
class T_Moderators private constructor(
	context: TableConstructor.Scope<T_Moderators>,
	usersTable: Table<T_Users, *>, chatsTable: Table<T_Chats, *>
) {
	val C_User = context.foreignRowReference("user", usersTable, ForeignRowReference.OnDelete.CASCADE)
	val C_Chat = context.foreignRowReference("chat", chatsTable, ForeignRowReference.OnDelete.CASCADE)
	val C_Ordinal = context.column("can_create_queues", context.types.BOOLEAN)
	val C_CanCloseQueues = context.column("can_close_queues", context.types.BOOLEAN)

	val U_UserInQueue = context.uniqueIndex("user_in_chat", true, this.C_User, this.C_Chat)

	private class _Constructor(
		private val usersTable: Table<T_Users, *>,
		private val chatsTable: Table<T_Chats, *>,
	) : TableConstructor<T_Moderators> {
		override fun createTable(context: TableConstructor.Scope<T_Moderators>) =
			T_Moderators(context, this.usersTable, this.chatsTable)
	}

	companion object Constructor {
		operator fun invoke(usersTable: Table<T_Users, *>, chatsTable: Table<T_Chats, *>): TableConstructor<T_Moderators> =
			_Constructor(usersTable, chatsTable)
	}
}